unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, registry;

const LENG=255;

type
  Tfrm_main = class(TForm)
    bt_open: TButton;
    bt_create: TButton;
    bt_cut: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ListBox1: TListBox;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure bt_openClick(Sender: TObject);
    procedure bt_createClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bt_cutClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  pole1=array [0..LENG] of longint;
  pole2=array [0..LENG] of byte;
  pole3=array [0..LENG] of string;

procedure Stick(pocetsouboru:byte;velikosthlavicek:pole2;nazevsouboru:pole3;
                velikostsouboru:pole1;cestysouboru:pole3;cesta:string);
procedure Cut(cesta:string);

var
  frm_main: Tfrm_main;
  poso:byte;
  vehla:pole2;
  nazso:pole3;
  veliso:pole1;
  cestso:pole3;
  cest:string;
  count:integer;
  cesta:string;
  umisteni:string;

implementation

procedure Stick(pocetsouboru:byte;velikosthlavicek:pole2;nazevsouboru:pole3;
                velikostsouboru:pole1;cestysouboru:pole3;cesta:string);
var f,a:file; b:byte; i,j:integer; s:string; poles:pbyte;
    ch:char;
Begin
  AssignFile(f,cesta);
  Rewrite(f,1);
  BlockWrite(f,pocetsouboru,1);
  for i:=0 to pocetsouboru-1 do
    Begin
      BlockWrite(f,velikosthlavicek[i],1);
    End;
  for i:=0 to pocetsouboru-1 do
    Begin
      for j:=1 to length(nazevsouboru[i]) do
           BlockWrite(f,nazevsouboru[i][j],1);
      ch:='\';
      BlockWrite(f,ch,1);
      s:=inttostr(velikostsouboru[i]);
      for j:=1 to length(s) do
          BlockWrite(f,s[j],1);
      AssignFile(a,cestysouboru[i]);
      Reset(a,1);
      getmem(poles,velikostsouboru[i]);
      BlockRead(a,poles^,velikostsouboru[i]);
      BlockWrite(f,poles^,velikostsouboru[i]);
      freemem(poles);
      CloseFile(a);
    End;
  CloseFile(f);
End;

procedure Cut(cesta:string);
var i,j:integer; s,sh:string; f,a:file; ch:char; b:byte; poles:pbyte;
    pocetsouboru:byte; velikosthlavicek:pole2; velikost:longint;
Begin
  AssignFile(f,cesta);
  Reset(f,1);
  BlockRead(f,pocetsouboru,1);
  for i:=0 to pocetsouboru-1 do
    BlockRead(f,VelikostHlavicek[i],1);
  for i:=0 to pocetsouboru-1 do
    Begin
      ch:='0';
      s:='';
      sh:='';
      while ch<>'\' do
      Begin
            BlockRead(f,ch,1);
            if ch<>'\' then s:=s+ch;
      End;
      AssignFile(a,s);
      Rewrite(a,1);
      for j:=0 to (VelikostHlavicek[i]-length(s)-2) do
        Begin
          BlockRead(f,ch,1);
          sh:=sh+ch;
        End;
      velikost:=strtoint(sh);
      getmem(poles,velikost);
      BlockRead(f,poles^,velikost);
      BlockWrite(a,poles^,velikost);
      freemem(poles);
      CloseFile(a);
    End;
  CloseFile(f);
End;

procedure NactiNazvySouboru(var nazevsouboru:pole3);
var i:integer;
Begin
  with frm_main do
  Begin
  for i:=0 to ListBox1.Items.Count-1 do
      nazevsouboru[i]:=ExtractFileName(ListBox1.Items.Strings[i]);
  End;
End;

procedure NactiCestySouboru(var cestysouboru:pole3);
var i:integer;
Begin
  with frm_main do
  Begin
    for i:=0 to ListBox1.Items.Count-1 do
      cestysouboru[i]:=ListBox1.Items.Strings[i];
  End;
End;

procedure VypocitejVelikostSouboru(cestysouboru:pole3;pocetsouboru:byte;
                                    var velikostsouboru:pole1);
var f:file; l:longint; i:integer; b:byte;
Begin
  for i:=0 to pocetsouboru-1 do
    Begin
      l:=0;
      AssignFile(f,cestysouboru[i]);
      Reset(f,1);
      l:=FileSize(f);
      velikostsouboru[i]:=l;
      CloseFile(f);
    End;
End;

procedure VypocitejVelikostHlavicek(pocetsouboru:byte;nazevsouboru:pole3;
                      velikostsouboru:pole1;var velikosthlavicek:pole2);
var i:integer;
Begin
  for i:=0 to pocetsouboru-1 do
    Begin
       velikosthlavicek[i]:=length(nazevsouboru[i])+
              length(inttostr(velikostsouboru[i]))+1;
    End;
End;

procedure NactiSoubory(cesta:string);
var f:file; b:byte; i,j:integer; l:longint; pocetsouboru:byte; ch:char;
    velikosthlavicek:pole2; s,sh:string; poles:pbyte;
Begin
  with frm_main do
  Begin
  AssignFile(f,cesta);
  Reset(f,1);
  BlockRead(f,pocetsouboru,1);
  Label1.Caption:='Count: '+inttostr(pocetsouboru);
  for i:=0 to pocetsouboru-1 do
    Begin
      BlockRead(f,b,1);
      velikosthlavicek[i]:=b;
    End;
  for i:=0 to pocetsouboru-1 do
    Begin
      s:='';
      ch:='0';
      sh:='';
      while ch<>'\' do
        Begin
          BlockRead(f,ch,1);
          if ch<>'\' then s:=s+ch;
        End;
      ListBox1.Items.Add(s);
      for j:=0 to (VelikostHlavicek[i]-length(s)-2) do
        Begin
          BlockRead(f,ch,1);
          sh:=sh+ch;
        End;
      l:=strtoint(sh);
      getmem(poles,l);
      blockread(f,poles^,l);
      freemem(poles);
    End;
  CloseFile(f);
  Count:=pocetsouboru;
  End;
End;

procedure ExtrahujJeden(cestaso:string;poradi:integer);
var f,a:file; i,j:integer; l:longint; ch:char; b:byte; pocetsouboru:byte;
    velikosthlavicek:pole2; s,sh:string;
Begin
  AssignFile(f,cestaso);
  Reset(f,1);
  BlockRead(f,pocetsouboru,1);
  for i:=0 to pocetsouboru-1 do
    Begin
      BlockRead(f,b,1);
      velikosthlavicek[i]:=b;
    End;
  for i:=0 to poradi-2 do
    Begin
      s:='';
      ch:='0';
      sh:='';
      while ch<>'\' do
        Begin
          BlockRead(f,ch,1);
          if ch<>'\' then s:=s+ch;
        End;
      for j:=0 to (VelikostHlavicek[i]-length(s)-2) do
        Begin
          BlockRead(f,ch,1);
          sh:=sh+ch;
        End;
      l:=strtoint(sh);
      for j:=1 to l do
        BlockRead(f,b,1);
    End;
  s:='';
  ch:='0';
  sh:='';
  while ch<>'\' do
    Begin
      BlockRead(f,ch,1);
      if ch<>'\' then s:=s+ch;
    End;
  AssignFile(a,s);
  Rewrite(a,1);
  for j:=0 to (VelikostHlavicek[poradi-1]-length(s)-2) do
    Begin
      BlockRead(f,ch,1);
      sh:=sh+ch;
    End;
  l:=strtoint(sh);
  for j:=1 to l do
    Begin
      BlockRead(f,b,1);
      BlockWrite(a,b,1);
    End;
  CloseFile(f);
  CloseFile(a);
End;

{$R *.dfm}

procedure Tfrm_main.bt_createClick(Sender: TObject);
begin
  if ListBox1.Items.Count=0 then
    showmessage('Can''t create packed file from nothing!')
    else
  if SaveDialog1.Execute then
     Begin
       poso:=ListBox1.Items.Count;
       NactiNazvySouboru(nazso);
       NactiCestySouboru(cestso);
       VypocitejVelikostSouboru(cestso,poso,veliso);
       VypocitejVelikostHlavicek(poso,nazso,veliso,vehla);
       Stick(poso,vehla,nazso,veliso,cestso,SaveDialog1.FileName);
       showmessage('Completed!')
     End;
end;

procedure Tfrm_main.bt_cutClick(Sender: TObject);
begin
  if (cesta='')or(ExtractFileExt(cesta)<>'.spf')or(ListBox1.ItemIndex=-1)then
    Showmessage('Cant''t unpack this!')
  else
    Begin
      ExtrahujJeden(cesta,ListBox1.ItemIndex+1);
      ShowMessage('File extracted!')
    End;
end;

procedure Tfrm_main.bt_openClick(Sender: TObject);
var s,sh:string;
begin
  if OpenDialog1.Execute then
    Begin
       s:=OpenDialog1.FileName;
       sh:=ExtractFileExt(s);
       if sh='.spf' then
        Begin
            cesta:=s;
            ListBox1.Clear;
            NactiSoubory(s);
        End
       else
        Begin
          if cesta<>'' then
            Begin
              ListBox1.Clear;
              Count:=0;
              cesta:='';
            End;
          Count:=Count+1;
          Label1.Caption:='Count: '+inttostr(Count);
          ListBox1.Items.Add(s);
        End;
    End;
end;

procedure Tfrm_main.Button1Click(Sender: TObject);
begin
   if (ExtractFileExt(cesta)<>'.spf') or (cesta='') then
    Showmessage('Can''t unpack this!')
   else
    Begin
      Cut(cesta);
      ShowMessage('File extracted!');
      cesta:='';
      count:=0;
      Label1.Caption:='Count: 0';
      ListBox1.Items.Clear;
    End;
end;

procedure Tfrm_main.Button2Click(Sender: TObject);
begin
  Cesta:='';
  ListBox1.Clear;
  Count:=0;
  Label1.Caption:='Count: 0';
end;

procedure Tfrm_main.Button3Click(Sender: TObject);
var reg:TRegistry;
begin
  reg:=TRegistry.Create;
  try
    reg.RootKey := HKEY_CLASSES_ROOT;
    if reg.OpenKey('.spf', True) then
      begin
        reg.WriteString('', ' S''n''C packed file');
        reg.CloseKey;
      end;
    if reg.OpenKey('file SPF', true) then
      begin
        reg.WriteString('', 'Files packed by S''n''P''');
        reg.CloseKey;
      end;
    if reg.OpenKey('file SPF\DefaultIcon', true) then
      begin
        reg.WriteString('', umisteni+', 1');
        reg.CloseKey;
      end;
    if reg.OpenKey('file SPF\Shell\Open\Command', true) then
      begin
        reg.WriteString('', umisteni+'%1');
        reg.CloseKey;
      end;
  finally
    reg.Free;
  end;
  showmessage('Files was associated!');
end;

procedure Tfrm_main.Button4Click(Sender: TObject);
var reg:TRegistry;
begin
  reg:=TRegistry.Create;
  try
    reg.RootKey := HKEY_CLASSES_ROOT;
    if reg.DeleteKey('.spf') then
      Begin
        reg.DeleteKey('file SPF');
        showmessage('Files was unassociated!');
      End
    else
      ShowMessage('Files is not associated!');
  finally
    reg.Free;
  end;
end;

procedure Tfrm_main.FormCreate(Sender: TObject);
var sh:string;
begin
  Label1.Caption:='Count: 0';
  Count:=0;
  cesta:='';
  umisteni:=GetCurrentDir();
  umisteni:=umisteni+'\'+Application.ExeName;
  if ParamCount>0 then
    Begin
      cesta:=ParamStr(1);
      sh:=ExtractFileExt(cesta);
       if sh='.spf' then
        Begin
            ListBox1.Clear;
            NactiSoubory(cesta);
        End;
    End;
end;

procedure Tfrm_main.ListBox1DblClick(Sender: TObject);
begin
  bt_cutClick(self);
end;

end.
